// p[^錾


float4 MaterialDiffuse   : DIFFUSE  < string Object = "Geometry"; >;
// @ϊs
float4x4 matWVP      : WORLDVIEWPROJECTION;
float4x4 matW	     : WORLD;

float3   CameraPosition    : POSITION  < string Object = "Camera"; >;

// MMD{sampler㏑Ȃ߂̋LqłB폜sB
sampler MMDSamp0 : register(s0);
sampler MMDSamp1 : register(s1);
sampler MMDSamp2 : register(s2);

// IuWFNg̃eNX`
texture ObjectTexture: MATERIALTEXTURE;
sampler ObjTexSampler = sampler_state {
    texture = <ObjectTexture>;
    MINFILTER = LINEAR;
    MAGFILTER = LINEAR;
};


///////////////////////////////////////////////////////////////////////////////////////////////
// IuWFNg`iZtVhEOFFj

struct VS_OUTPUT
{
    float4 Pos        : POSITION;    // ˉeϊW
    float3 WPos  	  : TEXCOORD0;
    float2 ObjTex	  : TEXCOORD1;
};

// _VF[_
VS_OUTPUT Basic_VS(float4 Pos : POSITION, float3 Normal : NORMAL,float2 Tex: TEXCOORD0)
{
    VS_OUTPUT Out = (VS_OUTPUT)0;

    Out.Pos = mul( Pos, matWVP );
    Out.WPos = mul(Pos,matW).xyz;
    Out.ObjTex = Tex;
    return Out;
}

// sNZVF[_
float4 Basic_PS( VS_OUTPUT IN, uniform bool useTex ) : COLOR
{
	float alpha = MaterialDiffuse.a;

	if(useTex)
	{
		alpha = tex2D(ObjTexSampler,IN.ObjTex).a;
	}
	return float4(IN.WPos,alpha > 0.9);
}

// IuWFNg`peNjbN
technique MainTec_1 < string MMDPass = "object"; bool UseTexture = false;> {
    pass DrawObject
    {
        VertexShader = compile vs_2_0 Basic_VS();
        PixelShader  = compile ps_2_0 Basic_PS(false);
    }
}

// IuWFNg`peNjbN
technique MainTecBS_1  < string MMDPass = "object_ss"; bool UseTexture = false;> {
    pass DrawObject {
        AlphaBlendEnable = FALSE;
        VertexShader = compile vs_2_0 Basic_VS();
        PixelShader  = compile ps_2_0 Basic_PS(false);
    }
}
// IuWFNg`peNjbN
technique MainTec_2 < string MMDPass = "object"; bool UseTexture = true;> {
    pass DrawObject
    {
        VertexShader = compile vs_2_0 Basic_VS();
        PixelShader  = compile ps_2_0 Basic_PS(true);
    }
}

// IuWFNg`peNjbN
technique MainTecBS_2  < string MMDPass = "object_ss"; bool UseTexture = true;> {
    pass DrawObject {
        AlphaBlendEnable = FALSE;
        VertexShader = compile vs_2_0 Basic_VS();
        PixelShader  = compile ps_2_0 Basic_PS(true);
    }
}
technique EdgeTec < string MMDPass = "edge"; > {

}
technique ShadowTech < string MMDPass = "shadow";  > {
    
}

///////////////////////////////////////////////////////////////////////////////////////////////
